/*
** CCTDE - Covert Channels and Tunnels Detection Engine - v0.1
** Copyright (C) 2003,2004 Simon Castro - scastro@entreelibre.com
**
** This file is part of CCTDE - v0.1 (C) 2003,2004 Simon Castro.
** 
** Cctde is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctde is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctde; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
** System header files
*/

#include <stdio.h>
#include <stdlib.h>

/*
** Our list definition
*/

typedef struct s_list_elem {
  struct s_list_elem *prev;
  struct s_list_elem *next;

  void *data;
  u_int32_t sizeofdata;
} t_list_elem;

typedef struct s_list_main {
  u_int32_t elem_nb;
  u_int32_t sizeof_elem;

  t_list_elem *first;
  t_list_elem *last;
  t_list_elem *ladded;
  t_list_elem *lupdated;
} t_list_main;

void *look_for_elem(t_list_main *lm, void *data,int (*seek_function)());
void *reverse_look_for_elem(t_list_main *lm, void *data,int (*seek_function)());
void *look_for_elem_and_count(t_list_main *lm, void *data,int (*seek_function)(),int stop);
int remove_elem(t_list_main *lm, t_list_elem *ptr, int remtype);
t_list_elem *replace_elem(t_list_main *lm, t_list_elem *old, t_list_elem *new);
t_list_elem *update_elem(t_list_elem *elem, void *data,int (*update_function)());
void browse_existing_elems(t_list_main *lm, void (*display_function)());
void browse_existing_elems_until(t_list_main *lm, void (*display_function)(),int until_this);
t_list_elem *add_to_list_here(t_list_main *lm, void *data, u_int32_t sizeofdata,t_list_elem *ptr_next, int addtype);
t_list_elem *add_to_list(t_list_main *lm, void *data, u_int32_t sizeofdata,int addtype);
void debug_list(t_list_main lm);
void init_main_list(t_list_main *list_main);


