/*
** CCTDE - Covert Channels and Tunnels Detection Engine - v0.1
** Copyright (C) 2003,2004 Simon Castro - scastro@entreelibre.com
**
** This file is part of CCTDE - v0.1 (C) 2003,2004 Simon Castro.
** 
** Cctde is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctde is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctde; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/cctde.h"

/*
** Main correlation function
*/

int correlate_upcon(t_con_track *ptr)
{
  upcon_detect_uptime(ptr);
  upcon_detect_packets_amount(ptr);
  upcon_detect_bytes_amount(ptr);
  return (1);
}

int correlate_and_alert()
{
  int i;
  t_con_track *ptr;

  /* 
  ** First doing detection on current connections :
  **   $ Connection lasting for more than x seconds;
  **   $ More than x rx and/or tx packets on the same connection;
  **   $ More than x rx and/or tx bytes on the same connection;
  */
  for(i=0; i<CON_HASH_SIZE; i++) 
    if (G_con_track[i] != NULL)
      for (ptr = G_con_track[i]; ptr != NULL; ptr = ptr->next)
	correlate_upcon(ptr);
  
  /* 
  ** Now doing detection on each stored clients for the current timeline period
  **   $ Global uptime greater than x seconds;
  **   $ More than x tcp connection;
  **   $ More than x rx and/or tx packets;
  **   $ More than x rx and/or tx bytes;
  **   managing alert reminder on % increase and on time periods
  */
  look_for_elem(&G_cctde_infos.client_list,(void *) NULL,basic_client_stats);

  /*
  ** Doing the same for stored servers
  */
  look_for_elem(&G_cctde_infos.client_list,(void *) NULL,basic_server_stats);

  return (1);
}
