/*
** CCTDE - Covert Channels and Tunnels Detection Engine - v0.1
** Copyright (C) 2003,2004 Simon Castro - scastro@entreelibre.com
**
** This file is part of CCTDE - v0.1 (C) 2003,2004 Simon Castro.
** 
** Cctde is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctde is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctde; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/cctde.h"

int display_top_servers()
{
  u_int32_t tmp;

  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_CON]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_SRV_CON has %d recorded server(s).\n",	   
	       tmp,G_cctde_infos.TOPX_SRV_con.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_con),display_servers,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_UPTIME]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_SRV_UPTIME has %d recorded server(s).\n",
	       tmp,G_cctde_infos.TOPX_SRV_uptime.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_uptime),display_servers,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_PRX]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_SRV_PRX has %d recorded server(s).\n",
	       tmp,G_cctde_infos.TOPX_SRV_prx.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_prx),display_servers,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_PTX]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_SRV_PTX has %d recorded server(s).\n",
	       tmp,G_cctde_infos.TOPX_SRV_ptx.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_ptx),display_servers,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_BRX]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_SRV_BRX has %d recorded server(s).\n",
	       tmp,G_cctde_infos.TOPX_SRV_brx.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_brx),display_servers,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_BTX]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_SRV_BTX has %d recorded server(s).\n",
	       tmp,G_cctde_infos.TOPX_SRV_btx.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_btx),display_servers,tmp);
    }

  return (1);
}

int display_top_clients()
{
  u_int32_t tmp;

  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_CON]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_CL_CON has %d recorded client(s).\n",
	       tmp,G_cctde_infos.TOPX_CL_con.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_con),display_clients,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_UPTIME]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_CL_UPTIME has %d recorded client(s).\n",
	       tmp,G_cctde_infos.TOPX_CL_uptime.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_uptime),display_clients,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_PRX]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_CL_PRX has %d recorded client(s).\n",
	       tmp,G_cctde_infos.TOPX_CL_prx.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_prx),display_clients,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_PTX]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_CL_PTX has %d recorded client(s).\n",
	       tmp,G_cctde_infos.TOPX_CL_ptx.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_ptx),display_clients,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_BRX]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_CL_BRX has %d recorded client(s).\n",
	       tmp,G_cctde_infos.TOPX_CL_brx.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_brx),display_clients,tmp);
    }

  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_BTX]) != 0)
    {
      display_infos(stdout,"  o TOP_%d_CL_BTX has %d recorded client(s).\n",
	       tmp,G_cctde_infos.TOPX_CL_btx.elem_nb);
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_btx),display_clients,tmp);
    }

  return (1);
}

void display_timeline(t_time_storage *time_storage)
{
  if (G_cctde_infos.config.disp_tnc == 0)
    {
      if (time_storage->client_list.elem_nb != 0)
	{
	  display_infos (stdout,
			 "\n  o Time list created the %s and is %d secs long with %d clients.\n",
			 get_str_from_time_t(time_storage->time_creation),
			 time_storage->period,
			 time_storage->client_number);
	  display_infos(stdout,"    The %s : Tcp connections : %d, Packets : %d, Bytes: %d\n",
			get_str_from_time_t(time_storage->time_creation+time_storage->period),
			time_storage->tcp_conn_number,
			time_storage->packets_number,
			time_storage->data_amount);
	}
    }
  else
    {
      display_infos (stdout,
		     "\n  o Time list created the %s and is %d secs long with %d clients.\n",
		     get_str_from_time_t(time_storage->time_creation),
		     time_storage->period,
		     time_storage->client_number);
      display_infos(stdout,"    The %s : Tcp connections : %d, Packets : %d, Bytes: %d\n",
		    get_str_from_time_t(time_storage->time_creation+time_storage->period),
		    time_storage->tcp_conn_number,
		    time_storage->packets_number,
		    time_storage->data_amount);
    }

  browse_existing_elems(&(time_storage->client_list),display_clients_and_servers);
}

void display_clients(t_storage *client_infos)
{
  char time_fst[26];
  char time_last[26];

  bzero((char *) time_fst, 26);
  bzero((char *) time_last, 26);
  ts_print((struct timeval *) & client_infos->time_last_access, time_last);
  ts_print((struct timeval *) & client_infos->time_creation, time_fst);

  display_infos (stdout,"    # %s [%s- %s]\n      conn=%u, packets rx=%u tx=%u, bytes rx=%u tx=%u, Uptime global=%u\n",
           ip_uint_to_str(client_infos->ip),
	   time_fst,time_last,client_infos->tcp_nb,
           client_infos->packet_rx,client_infos->packet_tx,
           client_infos->bytes_rx,client_infos->bytes_tx,
	   client_infos->com_uptime);
}

void display_2nd_servers(t_storage *stored_infos)
{
  char time_fst[26];
  char time_last[26];

  bzero((char *) time_fst, 26);
  bzero((char *) time_last, 26);
  ts_print((struct timeval *) & stored_infos->time_last_access, time_last);
  ts_print((struct timeval *) & stored_infos->time_creation, time_fst);

  display_infos (stdout,"      $ %s:%d [%s- %s]\n        conn=%u, packets rx=%u tx=%u, bytes rx=%u tx=%u, Uptime global=%u\n",
           ip_uint_to_str(stored_infos->ip),stored_infos->port,
	   time_fst,time_last,stored_infos->tcp_nb,
           stored_infos->packet_rx,stored_infos->packet_tx,
           stored_infos->bytes_rx,stored_infos->bytes_tx,
	   stored_infos->com_uptime);
}

void display_clients_and_servers(t_storage *client_infos)
{
  char time_fst[26];
  char time_last[26];

  bzero((char *) time_fst, 26);
  bzero((char *) time_last, 26);
  ts_print((struct timeval *) & client_infos->time_last_access, time_last);
  ts_print((struct timeval *) & client_infos->time_creation, time_fst);

  display_infos (stdout,"    # %s [%s- %s]\n      conn=%u, packets rx=%u tx=%u, bytes rx=%u tx=%u, Uptime global=%u\n",
           ip_uint_to_str(client_infos->ip),
	   time_fst,time_last,client_infos->tcp_nb,
           client_infos->packet_rx,client_infos->packet_tx,
           client_infos->bytes_rx,client_infos->bytes_tx,
	   client_infos->com_uptime);

  browse_existing_elems(&(client_infos->second_list),display_2nd_servers);
}

void display_servers(t_storage *server_infos)
{
  char time_fst[26];
  char time_last[26];

  bzero((char *) time_fst, 26);
  bzero((char *) time_last, 26);
  ts_print((struct timeval *) & server_infos->time_last_access, time_last);
  ts_print((struct timeval *) & server_infos->time_creation, time_fst);

  display_infos (stdout,"    # %s:%u [%s- %s]\n      conn=%u, packets rx=%u tx=%u, bytes rx=%u tx=%u, Uptime global=%u\n",
           ip_uint_to_str(server_infos->ip),server_infos->port,
	   time_fst,time_last,server_infos->tcp_nb,
           server_infos->packet_rx,server_infos->packet_tx,
           server_infos->bytes_rx,server_infos->bytes_tx,
	   server_infos->com_uptime);
}

