/*
** CCTDE - Covert Channels and Tunnels Detection Engine - v0.1
** Copyright (C) 2003,2004 Simon Castro - scastro@entreelibre.com
**
** This file is part of CCTDE - v0.1 (C) 2003,2004 Simon Castro.
** 
** Cctde is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctde is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctde; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/cctde.h"

int wgrteq_con(t_storage *stored_view, t_storage *tmp_view)
{
  if (stored_view->tcp_nb >= tmp_view->tcp_nb)
    return(-1);
  return(1);
}

int wgrteq_uptime(t_storage *stored_view, t_storage *tmp_view)
{
  if (stored_view->com_uptime >= tmp_view->com_uptime)
    return(-1);
  return(1);
}

int wgrteq_prx(t_storage *stored_view, t_storage *tmp_view)
{
  if (stored_view->packet_rx >= tmp_view->packet_rx)
    return(-1);
  return(1);
}

int wgrteq_ptx(t_storage *stored_view, t_storage *tmp_view)
{
  if (stored_view->packet_tx >= tmp_view->packet_tx)
    return(-1);
  return(1);
}

int wgrteq_brx(t_storage *stored_view, t_storage *tmp_view)
{
  if (stored_view->bytes_rx >= tmp_view->bytes_rx)
    return(-1);
  return(1);
}

int wgrteq_btx(t_storage *stored_view, t_storage *tmp_view)
{
  if (stored_view->bytes_tx >= tmp_view->bytes_tx)
    return(-1);
  return(1);
}

int store_top_X(t_list_elem *stored, t_list_main *lm,
		int (*match_fn)(),int (*top_fn)(), int top_size)
{
  t_list_elem *ptr;

  /* First check if we'll be in TopX */
  ptr = look_for_elem_and_count(lm,stored->data,top_fn,top_size);
  if (ptr == NULL && lm->elem_nb == top_size)
    return (-1);

  /* If we already exist in TopX, then remove the record */
  if ((ptr = look_for_elem(lm,stored->data,match_fn)))
    {
      if (remove_elem(lm,ptr,0) < 1)
	return (-1);
    }
  else 
    {
      /* 
      ** We don't exist in the current top, so we have to remove the last elem. 
      ** if we already have a full top
      */
      if (lm->last && lm->elem_nb == top_size && remove_elem(lm,lm->last,0) < 1)
	return (-1);
    }

  if (!(lm->first)) // No previous elem
    {
      if ((ptr = add_to_list(lm,stored->data,sizeof(t_storage),0)) == NULL)
	return (-1);
    }
  else
    {
      /* Take care that ptr can be NULL after next call if this is the last element ! */
      ptr = look_for_elem_and_count(lm,stored->data,top_fn,top_size);
      if ((ptr = add_to_list_here(lm,stored->data,sizeof(t_storage),ptr,0)) == NULL)
	return (-1);
    }
  return (1);
}
